indexing

	description:
		"Containers whose items are accessible through keys";

	status: "See notice at end of class";
	names: table, access;
	access: key, membership;
	contents: generic;
	date: "$Date: 1998/08/12 16:50:02 $";
	revision: "$Revision: 1.9 $"

deferred class TABLE [G, H] inherit

	BAG [G]
		rename
			put as bag_put
		end;

feature -- Access

	item, infix "@" (k: H): G is
			-- Entry of key `k'.
		require
			valid_key: valid_key (k)
		deferred
		end;

feature -- Status report

	valid_key (k: H): BOOLEAN is
			-- Is `k' a valid key?
		deferred
		end;

feature -- Element change

	put (v: G; k: H) is
			-- Associate value `v' with key `k'.
		require
			valid_key: valid_key (k)
		deferred
		end;

feature {NONE} -- Inapplicable

	bag_put (v: G) is
		do
		end

end -- class TABLE


--|----------------------------------------------------------------
--| EiffelBase: Library of reusable components for Eiffel.
--| Copyright (C) 1986-1998 Interactive Software Engineering (ISE).
--| For ISE customers the original versions are an ISE product
--| covered by the ISE Eiffel license and support agreements.
--| EiffelBase may now be used by anyone as FREE SOFTWARE to
--| develop any product, public-domain or commercial, without
--| payment to ISE, under the terms of the ISE Free Eiffel Library
--| License (IFELL) at http://eiffel.com/products/base/license.html.
--|
--| Interactive Software Engineering Inc.
--| ISE Building, 2nd floor
--| 270 Storke Road, Goleta, CA 93117 USA
--| Telephone 805-685-1006, Fax 805-685-6869
--| Electronic mail <info@eiffel.com>
--| Customer support e-mail <support@eiffel.com>
--| For latest info see award-winning pages: http://eiffel.com
--|----------------------------------------------------------------

